#ifndef GC_H
#define GC_H

#include "vecteur.h"
#include "matrice.h"


//! Gradient conjuge preconditionne. Retourne le nombre d'iterations, -1 a non convergence.
//! Probleme a resoudre A * x = b.
//! C - matrice du preconditionnement
//! eps - residu
//! m - nombre maximal d'iterations
int GradientConjugue (const Matrice &A, const Matrice &C, const Vecteur &b,
                      Vecteur &x, int m, double eps);

#endif
