#include <assert.h>
//#include "/home/ibr/Installs/gmm-3.0/include/gmm/gmm.h"
#include "/usr/local/include/gmm/gmm.h"

//=============================================================================
void solver_gmm (Matrice &iA, Vecteur &ib, Vecteur &ix, double &res, size_t &nit, size_t eps)
//=============================================================================
{
  cout << "solver_gmm" << endl;

  int n = iA.RetDim();
  //cout << iA.lignesind[n] << endl;
  gmm::row_matrix<gmm::wsvector<double> > A(n,n); //sparse format
  gmm::clear(A); // initialize to 0
  std::vector<double> b(n); //dense format
  std::vector<double> x(n);
  size_t restart = 50;       // restart parameter for GMRES
  gmm::iteration iter(eps);// Iteration object with the max residu
  gmm::identity_matrix PR;   // Optional preconditioner
  for (int j=0;j<n;j++){
    /*    cout << "wwwwwwwwwwwwwwwww" << endl;
	  cout << "debut : " << iA.lignesind[j] << " ; fin : " << iA.lignesind[j+1]-1 << endl; */
    for (int k=iA.lignesind[j];k<=iA.lignesind[j+1]-1;k++){
      A(iA.colonnes[k],j)=iA.valeurs[k];
    }
    b[j] = ib[j];
  }
  gmm::gmres(A, x, b, PR, restart, iter); // GMRES generalized minimum residual
  res = iter.get_res();
  nit = iter.get_iteration();
  for (int i = 0 ; i < n ; i++) 
  {
    ix[i] = x[i];
  }
}


