#ifndef FUNCTIONS_H
#define FUNCTIONS_H

//! Distance of two points.
double Dist (double x1, double y1, double x2, double y2);

//! Function for the calculation of the normal vector of the line given by 1,2, outward to 3.
void NormVectLine (double x1, double y1, double x2, double y2, double x3,
                   double y3, double n[2]);

//! Scalar product.
double ProdSc (double a[2], double b[2]);

//! Function for the calculation of a gradient of a linear function.
void CalcGrads (double A1, double A2, double B1, double B2, double C1, double C2, double b1,
                     double b2, double b3, double &gr1, double &gr2, double &cnst);

//! Compute the surface of a triangle.
double Surface (double A1, double A2, double B1, double B2, double C1, double C2);

//! Vector product.
void ProdVect (double u[3], double w[3], double x[3]);


#endif
