#include "ligne.h"

//=============================================================================
Ligne::Ligne ()
//=============================================================================
{
  nbcoef = 0;
}

//=============================================================================
Ligne::~Ligne ()
//=============================================================================
{
}

//=============================================================================
double Ligne::operator [] (int i) const
//=============================================================================
{ // const - on ne peut pas changer le vecteur ici
  int j;

  for (j = 0; j < nbcoef; j++) {
    if (i == colonnes[j]) // il y a deja quelque chose sur la colonne i
      return valeurs[j];
  }

  return 0.0; // sinon, l'element est nul
}

//=============================================================================
double & Ligne::operator [] (int i)
//=============================================================================
{ // double & - on peut changer des elements du vecteur
  int j;

  for (j = 0; j < nbcoef; j++) {
    if (i == colonnes[j]) // il y a deja quelque chose sur la colonne i
      return valeurs[j];
  }

  nbcoef++;               // augmenter la taille des elements non nuls de la ligne
  colonnes[j] = i;        // definir l'indice colonne
  valeurs[j] = 0.0;       // associer 0 a l'element
  return valeurs[j];      // envoyer l'adresse de l'element
}

//=============================================================================
void Ligne::Zero ()
//=============================================================================
{
  nbcoef = 0;
}


