#include <malloc.h>
#include <assert.h>
#include "maillage.h"

//=============================================================================
Maillage::Maillage (int ns, int nt)
//=============================================================================
{
  nbsom = ns;
  nbtriang = nt;
  sommets = new Sommet [ns];     // allocation dynamique de la memoire
  triangles = new EZTriangle [nt]; // allocation dynamique de la memoire
}

//=============================================================================
Maillage::~Maillage ()
//=============================================================================
{
  delete [] sommets;          // deallocation de la memoire
  sommets = NULL;             // par messure de securite
  delete [] triangles;        // deallocation de la memoire
  triangles = NULL;           // par messure de securite
}

//=============================================================================
Sommet & Maillage::operator [] (int i) const
//=============================================================================
{ // const - on ne peut pas changer le maillage
  assert (i >= 0 && i < nbsom); // arret si i < 0 ou i >= nbsom
  return sommets[i];
}

//=============================================================================
EZTriangle & Maillage::operator () (int i) const
//=============================================================================
{ // const - on ne peut pas changer le maillage
  assert (i >= 0 && i < nbtriang); // arret si i < 0 ou i >= nbtriang
  return triangles[i];
}

