#ifndef MAILLAGE_H
#define MAILLAGE_H

#include "sommet.h"
#include "triangle.h"

//! Classe d'un maillage.
class Maillage {

public:

  int nbsom;                  //!< Nombre des sommets.
  int nbtriang;               //!< Nombre des triangles.
  Sommet* sommets;            //!< Tableau des sommets.
  EZTriangle* triangles;        //!< Tableau des triangles.

  //! Constructeur.
  Maillage (int ns, int nt);

  //! Destructeur.
  ~Maillage ();

  //! Operateur d'acces aux sommets du maillage.
  Sommet & operator [] (int i) const;

  //! Operateur d'acces aux triangles du maillage.
  EZTriangle & operator () (int i) const;

};

#endif
