#ifndef MATRICE_H
#define MATRICE_H

#include <iostream.h>
#include "vecteur.h"
#include "ligne.h"

//! Classe d'une matrice reele creuse dans le "compressed row format".
class Matrice {

  int dim;                    //!< Dimension de la matrice.

public:

  int nbcoef;                 //!< Nombre maximal des coefficients non nuls.
  double* valeurs;            //!< Valeurs de la matrice.
  int* lignesind;             //!< Indices des valeurs se trouvant en debut des lignes de la matrice.
  int* colonnes;              //!< Indices des colonnes de la matrice.

  //! Constructeur.
  Matrice (int d, int nb);

  //! Destructeur;
  ~Matrice ();

  //! Retourne dimension de la matrice.
  int RetDim () const;

  //! Multiplication d'une matrice par un vecteur.
  Vecteur operator * (const Vecteur &V) const;

  //! Definit la ligne ind de la matrice par le vecteur ligne.
  void DefLigne (const Vecteur &ligne, int ind);

  //! Definit la ligne ind de la matrice par la ligne ligne.
  void DefLigne (const Ligne &ligne, int ind);

  //! Ecrire la matrice.
  friend ostream & operator << (ostream &os, const Matrice &M);
};


#endif
