#ifndef SOMMET_H
#define SOMMET_H

#define MAXVOIS 20   // nombre maximal de triangles qui partagent un sommet

class EZTriangle;

//! Classe d'un sommet d'un maillage.
class Sommet {

public:

  double x;                     //!< Coordonnee x.
  double y;                     //!< Coordonnee y.
  int ind;                      //!< Indice interieur (==1) / bord (==0).
  int num;                      //!< Numero du sommet pour un sommet interne.
  double cb;                    //!< Valeur de la condition au bord de type Dirichlet.
  EZTriangle* triangles[MAXVOIS]; //!< Tableau de pointeurs sur des triangles qui partagent le sommet.
  int nbtriang;                 //!< Nombre de triangles qui partagent le sommet.

  //! Constructeur par defaut vide.
  Sommet ();

  //! Constructeur.
  Sommet (double xx, double yy, int id);

  //! Destructeur;
  ~Sommet ();
};


#endif
