#ifndef TRIANGLE_H
#define TRIANGLE_H

#include "sommet.h"

//! Classe d'un triangle d'un maillage.
class EZTriangle {

public:

  Sommet* sommets[3];         //!< Tableau de pointeurs sur des sommets qui forment le triangle.
  int num;                    //!< Numero du triangle.
  double dif;                 //!< Coefficient de diffusion sur le triangle.
  double sour;                //!< Terme source sur le triangle.
  double mes;                 //!< Mesure (aire) du triangle.
  double fonctbas[3][2];      //!< Gradients des fonctions de base des elements finis.

  //! Constructeur par defaut vide.
  EZTriangle ();

  //! Constructeur.
  EZTriangle (Sommet* som1, Sommet* som2, Sommet* som3, double df, double sr);

  //! Destructeur.
  ~EZTriangle ();

  //! Fonction pour remplir mes et fonctbas a la base de l'information geometrique donnee dans les sommets.
  void Geometrie ();
};


#endif
